> For the complete documentation index, see [llms.txt](https://docs.namiml.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.namiml.com/sdk-reference/namipaywallmanager/displayedviewcontroller.md).

# displayedViewController

{% hint style="info" %}
Apple-only method.
{% endhint %}

```swift
NamiPaywallManager.displayedViewController()
```

Returns the last raised Nami Paywall view controller. Will be `.none` if the paywall is closed.

### Handling VC Alerts

```swift
NamiPurchaseManager.registerRestorePurchasesHandler { state, newPurchases, oldPurchases, error in
            let presentAlertFromVC = NamiPaywallManager.displayedViewController()
                    
            switch state {
                case .started:
                    print("starting restoring purchases")
            case .finished:
                // additionally may want to check that there are more items in
                // newPurchases than oldPurchases
                if oldPurchases != newPurchases {
                    print("Found restored purchases")
                    presentAlertFromVC?.dismiss(animated: false)
                } else {
                    let alert = UIAlertController(title: "Restore Purchase", message: "No previous purchases to restore", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: .default, handler: nil))
                    presentAlertFromVC!.present(alert, animated: true, completion: nil)
                }
            case .error:
                print("error restoring purchases")
            default:
                print("unknown case")
            }
        }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.namiml.com/sdk-reference/namipaywallmanager/displayedviewcontroller.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
